#include <windows.h>
#include "Event.hpp"

class AddEventArgs : public EventArgs
{
public:
    AddEventArgs() throw() {}
    virtual ~AddEventArgs() throw() {}
    // Member Variables
    unsigned long Value1;
    unsigned long Value2;
};

class TestSource : public IObject
{
public:
    TestSource() throw() {}
    virtual ~TestSource() throw() {}
    void Add(unsigned long val1,unsigned long val2) throw();
    // Event Variable
    Event OnAdd;
};

class TestHandler : public IObject
{
public:
    TestHandler() throw() {}
    virtual ~TestHandler() throw() {}
    // Handler Routine
    void __stdcall HandleAdd(IObject * pSender,AddEventArgs * pArgs) throw();
    // Global Handler Routine
    static void __stdcall GlobalHandleAdd(IObject * pSender,AddEventArgs * pArgs) throw();
};

extern "C" int __stdcall WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
    char * lpstrCmdLine,int nShowCmd) throw()
{
    TestSource mySource;
    TestHandler myHandler;
    
    Delegate * pDeleg1 = new Delegate(&myHandler,(EventHandler)&TestHandler::HandleAdd);
    Delegate * pDeleg2 = new Delegate((GlobalEventHandler)TestHandler::GlobalHandleAdd);
    
    mySource.OnAdd.AddHandler(pDeleg1);
    mySource.OnAdd.AddHandler(pDeleg2);
    
    mySource.Add(100,200);
    
    return 0;
}

void TestSource::Add(unsigned long val1,unsigned long val2) throw()
{
    AddEventArgs * pArgs = new AddEventArgs();
    
    pArgs->Value1 = val1;
    pArgs->Value2 = val2;
    
    OnAdd.Raise(this,pArgs);
    
    delete pArgs;
}

void __stdcall TestHandler::HandleAdd(IObject * pSender,AddEventArgs * pArgs) throw()
{
    const unsigned long dwSenderAddress = reinterpret_cast<unsigned long>(pSender);
    const unsigned long dwReceiverAddress = reinterpret_cast<unsigned long>(this);
    
    const unsigned long dwResult = pArgs->Value1 + pArgs->Value2;
    
    char szMessage[256];
    
    ::wsprintfA(szMessage,"EventHandler\r\nSender Object: %lX\r\nReceiving Object: %lX\r\nValue1: %lu    Value2: %lu\r\nResult: %lu",dwSenderAddress,dwReceiverAddress,pArgs->Value1,
        pArgs->Value2,dwResult);
        
    ::MessageBoxA(HWND_DESKTOP,szMessage,"OnAdd Event",MB_OK);
}

void __stdcall TestHandler::GlobalHandleAdd(IObject * pSender,AddEventArgs * pArgs) throw()
{
    const unsigned long dwSenderAddress = reinterpret_cast<unsigned long>(pSender);
    
    const unsigned long dwResult = pArgs->Value1 + pArgs->Value2;
    
    char szMessage[256];
    
    ::wsprintfA(szMessage,"GlobalEventHandler\r\nSenderAddress: %lX\r\nValue1: %lu    Value2: %lu\r\nResult: %lu",dwSenderAddress,pArgs->Value1,
        pArgs->Value2,dwResult);
        
    ::MessageBoxA(HWND_DESKTOP,szMessage,"OnAdd Event",MB_OK);
}
